#version 330

uniform mat4 NormalMatrix;
uniform mat4 MVMatrix;
uniform mat4 PMatrix;

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 color;
layout (location = 2) in vec3 normal;
layout (location = 3) in vec2 texCoord;

uniform vec2 offsets[50];

// the data to be sent to the fragment shader
out FragmentData {
    vec3 normal;
    vec4 color;
    vec2 texCoord;
} FDataOut;

void main(void)
{
    FDataOut.texCoord = texCoord;
    FDataOut.color = vec4(color,1.0);
    vec4 tmp = normalize((NormalMatrix * vec4(normal, 1.0)));
    FDataOut.normal = vec3(tmp.x, tmp.y, tmp.z);
    vec2 offset = offsets[gl_InstanceID];
    vec4 displace = vec4 (offset,0.0,0.0);
    gl_Position = PMatrix * (displace+MVMatrix * vec4(position, 1.0));
}
